#include "dmx_in.h"


enum {IDLE, BREAK, STARTB, STARTADR};			//DMX states

		 uint8_t 	 gDmxState;
		 uint8_t 	*gDmxPnt;
		 uint16_t	 DmxCount;


// DMX RX Initialisation

void init_dmx(void)
{
UBRRH  = 0;
UBRRL  = 1;						                //250kbaud, 8N2
UCSRC |= (3<<UCSZ0)|(1<<USBS);
UCSRB |= (1<<RXEN)|(1<<RXCIE);
gDmxState= IDLE;

uint8_t i;
for (i=0; i<dmx_channels; i++)
	{
	dmx_array[i]= 0;
	}
}


// DMX RX ISR

ISR (USART_RX_vect)
{
uint8_t USARTstate = UCSRA;						//get state
uint8_t DmxByte = UDR;							//get data
uint8_t DmxState = gDmxState;					//just get once from SRAM!!!
 
if (USARTstate & (1<<FE))						//check for break
	{
	UCSRA &= ~(1<<FE);							//reset flag
	DmxCount = dmx_address;						//reset frame counter
	gDmxState = BREAK;
	}

else if (DmxState == BREAK)
	{
	if (DmxByte == 0) 
		{
		gDmxState = STARTB;						//normal start code detected
		gDmxPnt = ((uint8_t*)dmx_array +1);
		}
	else gDmxState = IDLE;
	}
	
else if (DmxState == STARTB)
	{
	if (--DmxCount == 0)						//start address reached?
		{
		gDmxState = STARTADR;
		dmx_array[0] = DmxByte;
		}
	}

else if (DmxState == STARTADR)
	{
	uint8_t *DmxPnt;
	DmxPnt = gDmxPnt;
	*DmxPnt = DmxByte;
	if (++DmxPnt >= (dmx_array + dmx_channels)) //all ch received?
		{
		gDmxState = IDLE;
		}
	else gDmxPnt = DmxPnt;
	}							
}
